mod Ex03b

incl Mtex

incl Mtexrc

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Pairing Functions.  \end 

rem 
  \para \bf  Subsection. Catalan Pairing Function.  \end See the section \it  
  3.2 Course of Values Recursion  \end in [2]. 

rem 
  \para \bf  [CL] Remark.  \end The Catalan pairing function \ft x,y \end is 
  pre-defined in CL. 

rem 
  \para \bf  Basic properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 = y1,y2 -> x1 = y1 & x2 = y2
  \end
  \eq* 
    x < x,y & y < x,y
  \end
  \eq* 
    x = 0 \/ \e y\e z x = y,z
  \end

rem 
  \para \bf  Ordering properties of Catalan pairing function.  \end We have 
  \eq* 
    x1,x2 < y1,y2 <-> 
    |x1,x2| < |y1,y2| \/ |x1,x2| = |y1,y2| & (x1 < y1 \/ x1 = y1 & x2 < y2)
  \end
  \para where \ft |x| \end is the pair size function defined in the module \it  
  Standard  \end. 

rem 
  \para \bf  [CL] Remark.  \end The membership predicate \ft x in y \end, where 
  \eq* 
    x in y <-> \e i(i < L(y) & x = Tex_f2_pp_sub(y,i))
  \end
  \para is pre-defined in CL. Notation for its negation is \ft x !in y \end. 

rem 
  \para \bf  Bounded quantification with membership predicate.  \end Note that 
  we have 
  \eq* 
    x in y -> x < y
  \end
  \para Consequently, existential and universal quantifiers in contexts like 
  \eq* 
    \e x(x in y & Tex0_dotsc)
  \end
  \eq* 
    \a x(x in y -> Tex0_dotsc)
  \end
  \para are in fact bounded. Such quantifiers can be used in explicit 
  definitions of predicates with bounded formulas. 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para bounded quantifiers \ft \eb y y in x: R \end and 
         \ft \ab y y in x: R \end 
   \item \para \header* pred/2 Q  \end explicit definitions of predicates 
         \def 
           pred R 
           R(x) <-> \eb y y in x: Q(x,y)
         \end
         \def 
           pred R 
           R(x) <-> 
             \ab y y in x: Q(x,y)
         \end
  \end

